/* $RCSfile$ */
/* $Author$ */
/* $Date$ */
/* $Revision$ */

#include <sys/types.h>
#include "hdfi.h"
#include "cris.h"


int findSelectedSoftCamera_c(u_char  *telemetry,
                         u_long   index,
              struct ce_crisEvt   *event)

{
   u_char length;
      int valid;
   
   event->nbytes = telemetry[index];
   event->stim = telemetry[index+1] >> 7;
   event->G1 = (telemetry[index+2] >> 3) & 0x07;
   event->R1 = telemetry[index+2] & 0x07;
   event->got_2nd_tel = telemetry[index+3] >> 7;
   event->got_guard = (telemetry[index+3] >> 6) & 0x01;
   event->nblobs = telemetry[index+3] & 0x1f;
   index += 6;
   length = 6;

   if (event->got_2nd_tel) {
      event->G2 = (telemetry[index] >> 3) & 0x07;
      event->R2 = telemetry[index] & 0x07;
      length++;
   } else {
      event->G2 = 0x00;
      event->R2 = 0x00;
   }

   length += 0x03 * event->nblobs;
   length += 2;
   length += (0x03 * (event->R1 + 0x01) + 0x01) / 0x02;
   if (event->got_guard) 
      length += 0x02*event->G1 + 0x02*event->G2;
   if (event->got_2nd_tel) {
      length += 2;
      length += (0x03 * (event->R2 + 0x01) + 0x01) / 0x02;
   }
   if (event->stim)
      length += 4;

   valid = 0;
   if (event->nbytes != length) valid = 1;
   if (event->G1 > CE_CRIS_NGUARD) valid = 1;
   if (event->G2 > CE_CRIS_NGUARD) valid = 1;

   return valid;
}
