/* $RCSfile$ */
/* $Author$ */
/* $Date$ */
/* $Revision$ */

#include <sys/types.h>
#include "hdfi.h"
#include "cris.h"

#include "crisGetData/uncompressNPixel_c.h"


void unpackEventHeader_c(u_char  *telemetry,
                         u_long   *index,
              struct ce_crisEvt   *event)

{
   u_long byte;

   byte = *index;

   event->nbytes = telemetry[byte];
   event->stim = telemetry[byte+1] >> 7;
   event->prim_tel_pair = (telemetry[byte+1] >> 6) & 0x01;
   event->buffer_id = telemetry[byte+1] & 0x3f;
   event->guard_hi_or = telemetry[byte+2] >> 7;
   event->hazard = (telemetry[byte+2] >> 6) & 0x01;
   event->G1 = (telemetry[byte+2] >> 3) & 0x07;
   event->R1 = (telemetry[byte+2] & 0x07) + 0x02;
   event->got_2nd_tel = telemetry[byte+3] >> 7;
   event->got_guard = (telemetry[byte+3] >> 6) & 0x01;
   event->centroid_err = (telemetry[byte+3] >> 5) & 0x01;
   event->nblobs = telemetry[byte+3] & 0x1f;
   event->npix = uncompressNPixel_c(telemetry[byte+4]);
   event->sec_tel_act = telemetry[byte+5] >> 6;
   event->age = telemetry[byte+5] & 0x3f;
   byte += 6;

   if (event->got_2nd_tel) {
      event->G2 = (telemetry[byte] >> 3) & 0x07;
      event->R2 = (telemetry[byte] & 0x07) + 0x02;
      byte++;
   } else {
      event->G2 = 0x00;
      event->R2 = 0x00;
   }
   *index = byte;
}
