#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "hdfi.h"
#include "cris.h"
#include "sis.h"
#include "crisSisGetUtilities.h"

uint32 *getDaysTimeStamps(int day1996, char *structName) {
    char *pStructs, *pStructsStart;
    uint32 *pStampsStart, *pStamps, startStamp;
    int structCount, structSize;

    pStructsStart = (char *) getDaysStructs(day1996, structName);

    structSize = getStructSizeFromName(structName);
    pStructs = pStructsStart;
    structCount = 0;
    while (getTimeStamp(pStructs, structName)) {
	structCount++;
	pStructs += structSize;
    }
    printf("structCount = %d\n", structCount); /* */

    pStampsStart = calloc((structCount * 2) + 1, sizeof(uint32));

    pStamps = pStampsStart;
    pStructs = pStructsStart;
    while ((startStamp = getTimeStamp(pStructs, structName))) {
	*pStamps = startStamp;
	/* printf("startStamp = %ld\n", *pStamps); */
	pStamps++;
	*pStamps = getStopTimeStamp(pStructs, structName);

	    /* avoid confusion with terminal zero value in the array */
	if (*pStamps == 0) *pStamps = 1L;

	/* printf("stopStamp = %ld\n", *pStamps); */
	pStamps++;
	pStructs += structSize;
    }
    *pStamps = 0L;
    free(pStructsStart);

    return pStampsStart;
}
