#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

int openOrCreateFileToReadWrite(char *path) {
    int fd;
    char CANT_OPEN_ERROR_MSG[] = "Unable to open file %s\n\nExiting.\n\n";
    char CANT_CREATE_ERROR_MSG[] = "Unable to create file %s\n\nExiting.\n\n";

    if ((fd = open(path, O_RDWR, 0)) == -1) {
	    /* the file doesn't exist yet.  create it. */
	if ((fd = creat(path, 0666)) == -1) {
	    perror("openOrCreateFileToReadWrite\n\t");
	    fprintf(stderr, CANT_CREATE_ERROR_MSG, path);
	    exit(1);
	}
	close(fd);

	if ((fd = open(path, O_RDWR, 0)) == -1) {
		/* still can't open it?  there's a problem. */
	    perror("openOrCreateFileToReadWrite\n\t");
	    fprintf(stderr, CANT_OPEN_ERROR_MSG, path);
	    exit(1);
	}
    }

    return fd;
}
